# limestone
LSN API Documentation

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 2.0.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import limestone 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import limestone
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import limestone
from limestone.rest import ApiException
from pprint import pprint

configuration = limestone.Configuration()
# Configure OAuth2 access token for authorization: oauth2
configuration.access_token = 'YOUR_ACCESS_TOKEN'

# Defining host is optional and default to https://api.dallas-idc.com
configuration.host = "https://api.dallas-idc.com"
# Create an instance of the API class
api_instance = limestone.CoreApi(limestone.ApiClient(configuration))
core_name = 'core_name_example' # str | Name of core to return

try:
    # Get a core
    api_response = api_instance.get_core(core_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CoreApi->get_core: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.dallas-idc.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CoreApi* | [**get_core**](docs/CoreApi.md#get_core) | **GET** /v2/core/{core_name} | Get a core
*FacilityApi* | [**get_facility**](docs/FacilityApi.md#get_facility) | **GET** /v2/facility/{facility_name} | Get a facility
*FacilityApi* | [**get_facility_list**](docs/FacilityApi.md#get_facility_list) | **GET** /v2/facility | Get all facilities
*FacilityApi* | [**get_facility_stock**](docs/FacilityApi.md#get_facility_stock) | **GET** /v2/facility/{facility_name}/stock | Get a facility&#39;s stock
*ImageApi* | [**get_core_list**](docs/ImageApi.md#get_core_list) | **GET** /v2/core | Get all core
*ImageApi* | [**get_image**](docs/ImageApi.md#get_image) | **GET** /v2/image/{image_name} | Get an image
*ImageApi* | [**get_image_list**](docs/ImageApi.md#get_image_list) | **GET** /v2/image | Get all images
*JobApi* | [**get_job_status**](docs/JobApi.md#get_job_status) | **GET** /v2/job/{job_id} | Get a job status
*ProjectApi* | [**associate_project_server**](docs/ProjectApi.md#associate_project_server) | **POST** /v2/project/{project_id}/server/{server_id} | Associate a server with a project
*ProjectApi* | [**delete_project**](docs/ProjectApi.md#delete_project) | **DELETE** /v2/project/{project_id} | Delete a project
*ProjectApi* | [**delete_project_server**](docs/ProjectApi.md#delete_project_server) | **DELETE** /v2/project/{project_id}/server/{server_id} | Delete a project&#39;s server
*ProjectApi* | [**get_project**](docs/ProjectApi.md#get_project) | **GET** /v2/project/{project_id} | Get a project
*ProjectApi* | [**get_project_list**](docs/ProjectApi.md#get_project_list) | **GET** /v2/project | Get all projects
*ProjectApi* | [**get_project_quotas**](docs/ProjectApi.md#get_project_quotas) | **GET** /v2/project/{project_id}/quotas | Get a project&#39;s quotas
*ProjectApi* | [**get_project_servers**](docs/ProjectApi.md#get_project_servers) | **GET** /v2/project/{project_id}/server | Get a project&#39;s servers
*ProjectApi* | [**store_project**](docs/ProjectApi.md#store_project) | **POST** /v2/project | Create a project
*ProjectApi* | [**store_project_server**](docs/ProjectApi.md#store_project_server) | **POST** /v2/project/{project_id}/server | Add a server to a project
*SSHKeyApi* | [**delete_ssh_key**](docs/SSHKeyApi.md#delete_ssh_key) | **DELETE** /v2/sshkey/{name} | Delete an ssh key
*SSHKeyApi* | [**get_ssh_key**](docs/SSHKeyApi.md#get_ssh_key) | **GET** /v2/sshkey/{name} | Get an ssh key
*SSHKeyApi* | [**get_ssh_key_list**](docs/SSHKeyApi.md#get_ssh_key_list) | **GET** /v2/sshkey | Get all ssh keys
*SSHKeyApi* | [**store_ssh_key**](docs/SSHKeyApi.md#store_ssh_key) | **POST** /v2/sshkey | Create an ssh public key


## Documentation For Models

 - [Core](docs/Core.md)
 - [Disk](docs/Disk.md)
 - [Facility](docs/Facility.md)
 - [FacilityStock](docs/FacilityStock.md)
 - [Image](docs/Image.md)
 - [InlineObject](docs/InlineObject.md)
 - [InlineObject1](docs/InlineObject1.md)
 - [InlineObject2](docs/InlineObject2.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [Instance](docs/Instance.md)
 - [JobStatus](docs/JobStatus.md)
 - [Metadata](docs/Metadata.md)
 - [PartitionDisk](docs/PartitionDisk.md)
 - [PartitionDiskAllOf](docs/PartitionDiskAllOf.md)
 - [Project](docs/Project.md)
 - [ProjectQuotas](docs/ProjectQuotas.md)
 - [RaidDisk](docs/RaidDisk.md)
 - [RaidDiskAllOf](docs/RaidDiskAllOf.md)
 - [RaidDiskAllOfRaid](docs/RaidDiskAllOfRaid.md)
 - [Result](docs/Result.md)
 - [SSHKey](docs/SSHKey.md)
 - [Server](docs/Server.md)
 - [ServerCreate](docs/ServerCreate.md)
 - [ServerCreateParameters](docs/ServerCreateParameters.md)
 - [ServerCreateParametersWithOSDisk](docs/ServerCreateParametersWithOSDisk.md)
 - [ServerCreateParametersWithOSDiskAllOf](docs/ServerCreateParametersWithOSDiskAllOf.md)
 - [ServerCreateParametersWithPartitions](docs/ServerCreateParametersWithPartitions.md)
 - [ServerCreateParametersWithPartitionsAllOf](docs/ServerCreateParametersWithPartitionsAllOf.md)
 - [ServerCreateValidationError](docs/ServerCreateValidationError.md)
 - [ServerCreateValidationErrorResponse](docs/ServerCreateValidationErrorResponse.md)


## Documentation For Authorization


## oauth2

- **Type**: OAuth
- **Flow**: password
- **Authorization URL**: https://api.dallas-idc.com/oauth/authorize
- **Scopes**: 
 - *****: Interact with all
 - **jobs**: Interact with job status
 - **projects**: Interact with project resources


## Author

support@limestonenetworks.com


